#include "TcpFlow.h"
#define ARGS 2


main(int argc, char *argv[]){
	int sockfd, newsockfd, client_len, childpid, numbytes,numpackets, port, secs, select;
	long total_bytes;
	struct sockaddr_in server_addr, client_addr;
	char buf[MAXDATASIZE]; 	
	double start_time, stop_time, total_time, throughput;
		
	if(argc <= ARGS){
		printf("use %s <Port> <secs>\n", argv[0]);
		return -1;
	}
	
	port = atoi(argv[1]);
	secs = atoi(argv[2]);

	if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("Server: can't open stream socket\n");
		exit(-1);
	}
	
	bzero((char *) &server_addr, sizeof(server_addr));
	server_addr.sin_family = AF_INET;		 
	server_addr.sin_port = htons(port);	
	server_addr.sin_addr.s_addr = htonl(INADDR_ANY); 
	
	//printf("Waiting for client connection...\n");
	

	if (bind(sockfd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) {
		perror("Bind:");
		exit(-1);
	}
	
	if(listen(sockfd, MAX_CONNECTIONS) < 0){
		perror("Listen");
		exit(-1);
	}

	select=input_timeout(sockfd, secs);
	if (select==1){
		numpackets=-1;
		total_bytes = 0;
		client_len = sizeof(client_addr);
		if((newsockfd = accept(sockfd, (struct sockaddr *) &client_addr, &client_len)) < 0) perror("Accept");	
		start_time=return_time();	
		if ((childpid = fork())<0) perror("Fork");
		else
			if (childpid == 0){
				do{
					if((numbytes=recv(newsockfd, buf, MAXBUFFER, 0)) < 0){
						perror("Receive");
						close(sockfd);
						exit(0);
					}
					numpackets++;
					if(numbytes>0){
						total_bytes = total_bytes + numbytes;
						buf[numbytes]='\0';
					}
				}while(numbytes>0);
				close(sockfd);
				stop_time = return_time();
				total_time = (stop_time - start_time);
				throughput = (total_bytes *8)/(total_time * 1024);
				printf("Received: %d packets. Size: %d bytes. Time: %.3lf seconds. Throughput: %f Kb/s\n", numpackets, total_bytes, total_time, throughput);
				exit(0);
			}else{
				exit(0);
			}
		}
	printf("No client connection in %d secs\n", secs);

	close(sockfd);
	return 0;
}

